Loading...
Searching...
No Matches
Sip_privacy

## Data Structures

struct | sip_privacy_s
| Structure for Privacy header. More...

## Macros

#define | sip_privacy(sip)
| Access a SIP Privacy header structure sip_privacy_t from sip_t.
#define | SIP_PRIVACY_INIT()
| Initializer for structure sip_privacy_t.
#define | SIPTAG_PRIVACY(x)
| Tag list item for pointer to a Privacy header structure sip_privacy_t.
#define | SIPTAG_PRIVACY_REF(x)
| Tag list item for reference to a Privacy header pointer.
#define | SIPTAG_PRIVACY_STR(s)
| Tag list item for string with Privacy header value.
#define | SIPTAG_PRIVACY_STR_REF(x)
| Tag list item for reference to a Privacy header string.

## Typedefs

typedef struct sip_privacy_s | sip_privacy_t
| @

## Functions

issize_t | sip_privacy_d (su_home_t *, msg_header_t *, char *s, isize_t slen)
| Parse a SIP Privacy header.
issize_t | sip_privacy_e (char b[], isize_t bsiz, msg_header_t const *h, int flags)
| Print a SIP Privacy header.
sip_privacy_t * | sip_privacy_init (sip_privacy_t x[1])
| Initialize a structure sip_privacy_t.
int | sip_is_privacy (sip_header_t const *header)
| Test if header object is instance of sip_privacy_t.
sip_privacy_t * | sip_privacy_dup (su_home_t *home, sip_privacy_t const *hdr))
| Duplicate a list of Privacy header header structures sip_privacy_t.
sip_privacy_t * | sip_privacy_copy (su_home_t *home, sip_privacy_t const *hdr))
| Copy a list of Privacy header header structures sip_privacy_t.
sip_privacy_t * | sip_privacy_make (su_home_t *home, char const *s))
| Make a Privacy header structure sip_privacy_t.
sip_privacy_t * | sip_privacy_format (su_home_t *home, char const *fmt,...)))
| Make a Privacy header from formatting result.

## Variables

msg_hclass_t | sip_privacy_class []
| Header class for Privacy header.
tag_typedef_t | siptag_privacy
| Tag for Privacy header object.
tag_typedef_t | siptag_privacy_str
| Tag for string with Privacy header value.

## Detailed Description

## Macro Definition Documentation

## SIP_PRIVACY_INIT

#define SIP_PRIVACY_INIT | ( |  | ) |

Initializer for structure sip_privacy_t.

A static sip_privacy_t structure for Privacy header must be initialized with the SIP_PRIVACY_INIT() macro. For instance,

sip_privacy_t sip_privacy = SIP_PRIVACY_INIT;
sip_privacy
#define sip_privacy(sip)
Access a SIP Privacy header structure sip_privacy_t from sip_t.
Definition sip_protos.h:13935
sip_privacy_t
struct sip_privacy_s sip_privacy_t
@
Definition sip.h:208
SIP_PRIVACY_INIT
#define SIP_PRIVACY_INIT()
Initializer for structure sip_privacy_t.
Definition sip_protos.h:13952

## SIPTAG_PRIVACY

#define SIPTAG_PRIVACY | ( |  | x | ) |

Tag list item for pointer to a Privacy header structure sip_privacy_t.

The SIPTAG_PRIVACY() macro is used to include a tag item with a pointer to a sip_privacy_t structure in a tag list.

Parameters

  x | pointer to a sip_privacy_t structure, or NULL.

The corresponding tag taking reference parameter is SIPTAG_PRIVACY_REF().

## SIPTAG_PRIVACY_STR

#define SIPTAG_PRIVACY_STR | ( |  | s | ) |

Tag list item for string with Privacy header value.

The SIPTAG_PRIVACY_STR() macro is used to include a tag item with a string containing value of a sip_privacy_t header in a tag list.

Parameters

  s | pointer to a string containing Privacy header value, or NULL.

The string in SIPTAG_PRIVACY_STR() can be converted to a sip_privacy_t header structure by giving the string s has second argument to function sip_privacy_make().

The corresponding tag taking reference parameter is SIPTAG_PRIVACY_STR_REF().

## Typedef Documentation

## sip_privacy_t

typedef struct sip_privacy_s sip_privacy_t

@

The Privacy header is used by User-Agent to request privacy services from the network. Its syntax is defined in RFC 3323 as follows:

Privacy-hdr = "Privacy" HCOLON priv-value *(";" priv-value)
priv-value = "header" / "session" / "user" / "none" / "critical"
/ token

The parsed Privacy header is stored in sip_privacy_t structure.

The structure sip_privacy_t contains representation of a SIP Privacy header.

The sip_privacy_t is defined as follows:

typedef struct sip_privacy_s {
sip_common_t priv_common[1]; // Common fragment info
sip_error_t *priv_next; // Dummy link
msg_param_t const *priv_values; // List of privacy values
} sip_privacy_t;
sip_error_t
msg_error_t sip_error_t
@
Definition sip.h:134
sip_common_t
msg_common_t sip_common_t
Common part of all the header structures.
Definition sip.h:121
sip_privacy_s
Structure for Privacy header.
Definition sip.h:790
sip_privacy_s::priv_next
sip_error_t * priv_next
Dummy link.
Definition sip.h:792
sip_privacy_s::priv_common
sip_common_t priv_common[1]
Common fragment info.
Definition sip.h:791
sip_privacy_s::priv_values
msg_param_t const * priv_values
Privacy values
Definition sip.h:793

## Function Documentation

## sip_is_privacy()

int sip_is_privacy | ( | sip_header_t const * | header | ) |

inline

Test if header object is instance of sip_privacy_t.

Check if the header class is an instance of Privacy header object and return true (nonzero), otherwise return false (zero).

Parameters

  header | pointer to the header structure to be tested

Return values

  1 | (true) if the header is an instance of header privacy
  0 | (false) otherwise

## sip_privacy_copy()

sip_privacy_t * sip_privacy_copy | ( | su_home_t * | home,
|  | sip_privacy_t const * | hdr )

inline

Copy a list of Privacy header header structures sip_privacy_t.

The function sip_privacy_copy() copies a header structure hdr. If the header structure hdr contains a reference (`hdr->h_next`) to a list of headers, all the headers in that list are copied, too. The function uses given memory home to allocate all the memory areas used to copy the list of header structure hdr.

Parameters

  home | memory home used to allocate new structure
  hdr | pointer to the header structure to be copied

When copying, only the header structure and parameter lists attached to it are duplicated. The new header structure retains all the references to the strings within the old hdr header, including the encoding of the old header, if present.

Example
  privacy = sip_privacy_copy(home, sip->sip_privacy);
  sip_privacy_copy
  sip_privacy_t * sip_privacy_copy(su_home_t *home, sip_privacy_t const *hdr))
  Copy a list of Privacy header header structures sip_privacy_t.
  Definition sip_protos.h:14082

Returns
  A pointer to newly copied header structure, or NULL upon an error.

## sip_privacy_dup()

sip_privacy_t * sip_privacy_dup | ( | su_home_t * | home,
|  | sip_privacy_t const * | hdr )

inline

Duplicate a list of Privacy header header structures sip_privacy_t.

Duplicate a header structure hdr. If the header structure hdr contains a reference (`hdr->x_next`) to a list of headers, all the headers in the list are duplicated, too.

Parameters

  home | memory home used to allocate new structure
  hdr | header structure to be duplicated

When duplicating, all parameter lists and non-constant strings attached to the header are copied, too. The function uses given memory home to allocate all the memory areas used to copy the header.

Example
  privacy = sip_privacy_dup(home, sip->sip_privacy);
  sip_privacy_dup
  sip_privacy_t * sip_privacy_dup(su_home_t *home, sip_privacy_t const *hdr))
  Duplicate a list of Privacy header header structures sip_privacy_t.
  Definition sip_protos.h:14039

Returns
  A pointer to the newly duplicated sip_privacy_t header structure, or NULL upon an error.

## sip_privacy_format()

sip_privacy_t * sip_privacy_format | ( | su_home_t * | home,
|  | char const * | fmt,
|  |  | ... )

inline

Make a Privacy header from formatting result.

Make a new sip_privacy_t object using formatting result as its value. The function first prints the arguments according to the format fmt specified. Then it allocates a new header structure, and parses the formatting result to the structure sip_privacy_t.

Parameters

  home | memory home used to allocate new header structure.
  fmt | string used as a printf()-style format
  ... | argument list for format

Returns
  A pointer to newly makes header structure, or NULL upon an error.

## sip_privacy_init()

sip_privacy_t * sip_privacy_init | ( | sip_privacy_t | x[1] | ) |

inline

Initialize a structure sip_privacy_t.

An sip_privacy_t structure for Privacy header can be initialized with the sip_privacy_init() function/macro. For instance,

sip_privacy_t sip_privacy;
sip_privacy_init(&sip_privacy);
sip_privacy_init
sip_privacy_t * sip_privacy_init(sip_privacy_t x[1])
Initialize a structure sip_privacy_t.
Definition sip_protos.h:13970

## sip_privacy_make()

sip_privacy_t * sip_privacy_make | ( | su_home_t * | home,
|  | char const * | s )

inline

Make a Privacy header structure sip_privacy_t.

The function sip_privacy_make() makes a new sip_privacy_t header structure. It allocates a new header structure, and decodes the string s as the value of the structure.

Parameters

  home | memory home used to allocate new header structure.
  s | string to be decoded as value of the new header structure

Returns
  A pointer to newly maked sip_privacy_t header structure, or NULL upon an error.

## Variable Documentation

## sip_privacy_class

msg_hclass_t sip_privacy_class[]

extern

Header class for Privacy header.

The header class sip_privacy_class defines how a SIP Privacy header is parsed and printed. It also contains methods used by SIP parser and other functions to manipulate the sip_privacy_t header structure.

Sofia-SIP 1.12.11devel - Copyright (C) 2006 Nokia Corporation. All rights reserved. Licensed under the terms of the GNU Lesser General Public License.